/***************************************************************************
 *   Copyright (C) 2006 by Tomasz Salacinski   *
 *   distortion@vp.pl   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "advancedserverflagsclass.h"

advancedServerFlagsClass::advancedServerFlagsClass(QWidget *parent, const char *name, QString sectionName, int sectionNum, QString xorgFile, int type)
    :advFlagsDlg(parent, name)
{
xFile = xorgFile;
x = new xorgConf();
x->saveXorg(xFile);
setLocale(type);
sectName = sectionName;
sectNum = sectionNum;


//Checking checkboxes
if (x->checkOption(sectionName, sectionNum, "DisableVidModeExtension"))    { checkBox25->setChecked(TRUE); }
if (x->checkOption(sectionName, sectionNum, "AllowNonLocalXvidtune"))      { checkBox26->setChecked(TRUE); }
if (x->checkOption(sectionName, sectionNum, "DisableModInDev"))            { checkBox27->setChecked(TRUE); }
if (x->checkOption(sectionName, sectionNum, "AllowNonLocalModInDev"))      { checkBox28->setChecked(TRUE); }
if (x->checkOption(sectionName, sectionNum, "VTSysReq"))                   { checkBox29->setChecked(TRUE); }
if (x->checkOption(sectionName, sectionNum, "XkbDisable"))                 { checkBox30->setChecked(TRUE); }

if (x->getOption(sectionName, sectionNum, "HandleSpecialKeys") != "")
{
checkBox32->setChecked(TRUE);
if (x->getOption(sectionName, sectionNum, "HandleSpecialKeys") == "Always") { comboBox14->setCurrentItem(0); }
if (x->getOption(sectionName, sectionNum, "HandleSpecialKeys") == "Never") { comboBox14->setCurrentItem(1); }
if (x->getOption(sectionName, sectionNum, "HandleSpecialKeys") == "WhenNeeded") { comboBox14->setCurrentItem(2); }
}
if (x->getOption(sectionName, sectionNum, "Pixmap") != "")
{
checkBox31->setChecked(TRUE);
if (x->getOption(sectionName, sectionNum, "Pixmap") == "24") { comboBox13->setCurrentItem(0); }
if (x->getOption(sectionName, sectionNum, "Pixmap") == "32") { comboBox13->setCurrentItem(1); }
}
if (x->getOption(sectionName, sectionNum, "VTInit") != "")
{
groupBox16->setChecked(TRUE);
lineEdit13->setText(x->getOption(sectionName, sectionNum, "VTInit"));
}



}

QString advancedServerFlagsClass :: returnXFile()
{
return x->returnConfig();
}

void advancedServerFlagsClass :: specialKeysHandler()
{
if (checkBox32->isChecked()) { comboBox14->setEnabled(TRUE); }
if (!checkBox32->isChecked()) { comboBox14->setEnabled(FALSE); }
}

void advancedServerFlagsClass :: pixmapHandler()
{
if (checkBox31->isChecked()) { comboBox13->setEnabled(TRUE); }
if (!checkBox31->isChecked()) { comboBox13->setEnabled(FALSE); }
}

void advancedServerFlagsClass :: accept()
{
//Saving settings
QString y = "True";
if (checkBox25->isChecked()) { x->saveOption(sectName, sectNum, "DisableVidModeExtension", 1, y); }
if (!checkBox25->isChecked()) { x->removeOption(sectName, sectNum, "DisableVidModeExtension"); }
if (checkBox26->isChecked()) { x->saveOption(sectName, sectNum, "AllowNonLocalXvidtune", 1, y); }
if (!checkBox26->isChecked()) { x->removeOption(sectName, sectNum, "AllowNonLocalXvidtune"); }
if (checkBox27->isChecked()) { x->saveOption(sectName, sectNum, "DisableModInDev", 1, y); }
if (!checkBox27->isChecked()) { x->removeOption(sectName, sectNum, "DisableModInDev"); }
if (checkBox28->isChecked()) { x->saveOption(sectName, sectNum, "AllowNonLocalModInDev", 1, y); }
if (!checkBox28->isChecked()) { x->removeOption(sectName, sectNum, "AllowNonLocalModInDev"); }
if (checkBox29->isChecked()) { x->saveOption(sectName, sectNum, "VTSysReq", 1, y); }
if (!checkBox29->isChecked()) { x->removeOption(sectName, sectNum, "VTSysReq"); }
if (checkBox30->isChecked()) { x->saveOption(sectName, sectNum, "XkbDisable", 1, y); }
if (!checkBox30->isChecked()) { x->removeOption(sectName, sectNum, "XkbDisable"); }
if (checkBox32->isChecked()) 
{
if (comboBox14->currentItem() == 0) { x->saveOption(sectName, sectNum, "HandleSpecialKeys", 1, "Always"); }
if (comboBox14->currentItem() == 1) { x->saveOption(sectName, sectNum, "HandleSpecialKeys", 1, "Never"); }
if (comboBox14->currentItem() == 2) { x->saveOption(sectName, sectNum, "HandleSpecialKeys", 1, "WhenNeeded"); }
}
if (!checkBox32->isChecked()) { x->removeOption(sectName, sectNum, "HandleSpecialKeys"); }
if (checkBox31->isChecked()) 
{
if (comboBox13->currentItem() == 0) { x->saveOption(sectName, sectNum, "Pixmap", 1, "24"); }
if (comboBox13->currentItem() == 1) { x->saveOption(sectName, sectNum, "Pixmap", 1, "32"); }
}
if (!checkBox31->isChecked()) { x->removeOption(sectName, sectNum, "Pixmap"); }

if (groupBox16->isChecked()) { x->saveOption(sectName, sectNum, "VTInit", 1, lineEdit13->text()); }
if (!groupBox16->isChecked()) { x->removeOption(sectName, sectNum, "VTInit"); }

close();
}


#include "advancedserverflagsclass.moc"
