/***************************************************************************
 *   Copyright (C) 2006 by Tomasz Salacinski   *
 *   distortion@vp.pl   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "gammadialogclass.h"

GammaDialogClass::GammaDialogClass(QWidget *parent, const char *name, int number, QString xorgFile)
    :gammaDialog(parent, name)
{
x = new xorgConf();
x->saveXorg(xorgFile);
setLocale();
secNum = number;

bool ok;
if (!x->valExists("Monitor", number, "Gamma"))
{
gammaGroupBox->setChecked(FALSE);
}
else
{
gammaGroupBox->setChecked(TRUE);
QString gamma = x->getGamma(number);

if(gamma.contains(" ") == 0)
{
gammaSlider->setValue(gamma.remove(".").remove(",").toInt(&ok, 10));
}

if (gamma.contains(" ") == 2)
{
redSlider ->setValue(gamma.section(" ", 0, 0).remove(".").remove(",").toInt(&ok, 10));
greenSlider->setValue(gamma.section(" ", 1, 1).remove(".").remove(",").toInt(&ok, 10));
blueSlider->setValue(gamma.section(" ", 2, 2).remove(".").remove(",").toInt(&ok, 10));
}
}




}

QString GammaDialogClass :: returnXorg()
{
return x->returnConfig();
}

void GammaDialogClass :: gammaSliderChange()
{
int val = gammaSlider->value();
redSlider->setValue(val);
blueSlider->setValue(val);
greenSlider->setValue(val);
gammaSpinBox->setValue(val);
}

void GammaDialogClass :: gammaSpinBoxChange()
{
gammaSlider->setValue(gammaSpinBox->value());
}

void GammaDialogClass :: blueSliderChange()
{
blueSpinBox->setValue(blueSlider->value());
}

void GammaDialogClass :: redSliderChange()
{
redSpinBox->setValue(redSlider->value());
}

void GammaDialogClass :: greenSliderChange()
{
greenSpinBox->setValue(greenSlider->value());
}

void GammaDialogClass :: resetSliders()
{
gammaSlider->setValue(10);
gammaSlider->setValue(11);
gammaSlider->setValue(10);
}

void GammaDialogClass :: greenSpinBoxChange()
{
greenSlider->setValue(greenSpinBox->value());
}

void GammaDialogClass :: blueSpinBoxChange()
{
blueSlider->setValue(blueSpinBox->value());
}

void GammaDialogClass :: redSpinBoxChange()
{
redSlider->setValue(redSpinBox->value());
}

void GammaDialogClass :: accept()
{
if (!gammaGroupBox->isChecked()) { x->removeGamma(secNum); close(); }
if (gammaGroupBox->isChecked())
{
if (gammaSlider->value() == redSlider->value() && gammaSlider->value() == greenSlider->value() && gammaSlider->value() == blueSlider->value())
{
x->saveGamma(secNum, gammaSlider->value());
close();
}
else
{
x->saveGamma(secNum, redSlider->value(), greenSlider->value(), blueSlider->value());
close();
}


}


}


#include "gammadialogclass.moc"
