/***************************************************************************
 *   Copyright (C) 2006 by Tomasz Salacinski   *
 *   distortion@vp.pl   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "nvidiadriveroptionsbigdialog.h"

#include <qlcdnumber.h>
#include <iostream.h>

nvidiaDriverOptionsBigDialog::nvidiaDriverOptionsBigDialog(QWidget *parent, const char *name, QString xorgFile, int sectionNum)
    :nvidiaDialogSettings(parent, name)
{
x = new xorgConf();
x->saveXorg(xorgFile);
sectNum = sectionNum;

setLocale();

lCDNumber2->display(slider2->value());
lCDNumber2_2->display(slider2_2->value());
lCDNumber2_2_2->display(slider2_2_2->value());

//Starting... checkboxes
if (x->checkOption("Device", sectNum, "NoLogo")) { checkBox25->setChecked(TRUE); }
if (x->checkOption("Device", sectNum, "RenderAccel")) { checkBox26->setChecked(TRUE); }
if (x->checkOption("Device", sectNum, "NoRenderExtension")) { checkBox27_2->setChecked(TRUE); }
if (x->checkOption("Device", sectNum, "UBB")) { checkBox27->setChecked(TRUE); }
if (x->checkOption("Device", sectNum, "WindowFlip")) { checkBox27_3->setChecked(TRUE); }
if (x->checkOption("Device", sectNum, "PageFlip")) { checkBox27_3_2->setChecked(TRUE); }
if (x->checkOption("Device", sectNum, "Dac8Bit")) { checkBox31->setChecked(TRUE); }
if (x->checkOption("Device", sectNum, "Overlay")) { checkBox32->setChecked(TRUE); }
if (x->checkOption("Device", sectNum, "CIOverlay")) { checkBox33->setChecked(TRUE); }
if (x->checkOption("Device", sectNum, "OverlayDefaultVisual")) { checkBox35->setChecked(TRUE); }
if (x->checkOption("Device", sectNum, "UseEdidFreqs")) { checkBox15->setChecked(TRUE); }
if (x->checkOption("Device", sectNum, "IgnoreEDID")) { checkBox16->setChecked(TRUE); }

if (x->getOption("Device", sectNum, "Stereo") != "") { 
groupBox10->setChecked(TRUE); 
if (x->getOption("Device", sectNum, "Stereo") == "1") { kComboBox7DDC_Glasses->setCurrentItem(0); }
if (x->getOption("Device", sectNum, "Stereo") == "2") { kComboBox7DDC_Glasses->setCurrentItem(1); }
if (x->getOption("Device", sectNum, "Stereo") == "3") { kComboBox7DDC_Glasses->setCurrentItem(2); }
if (x->getOption("Device", sectNum, "Stereo") == "4") { kComboBox7DDC_Glasses->setCurrentItem(3); }
}

if (x->getOption("Device", sectNum, "NvAGP") != "") { 
groupBox18->setChecked(TRUE);
if (x->getOption("Device", sectNum, "NvAGP") == "0") { kComboBox14->setCurrentItem(0); }
if (x->getOption("Device", sectNum, "NvAGP") == "1") { kComboBox14->setCurrentItem(1); }
if (x->getOption("Device", sectNum, "NvAGP") == "2") { kComboBox14->setCurrentItem(2); }
if (x->getOption("Device", sectNum, "NvAGP") == "3") { kComboBox14->setCurrentItem(3); }
}

if (x->getOption("Device", sectNum, "DigitalVibrance") != "") { 
groupBox17->setChecked(TRUE);
bool ok;
int a = x->getOption("Device", sectNum, "DigitalVibrance").toInt(&ok, 10);
slider1->setValue(a);
}


if (x->getOption("Device", sectNum, "TwinView") != "") { 
groupBox19->setChecked(TRUE);
if (x->getOption("Device", sectNum, "TwinViewOrientation") != "")
{
checkBox40->setChecked(TRUE);
if (x->getOption("Device", sectNum, "TwinViewOrientation") == "RightOf") { kComboBox15y->setCurrentItem(0); } 
if (x->getOption("Device", sectNum, "TwinViewOrientation") == "LeftOf") { kComboBox15y->setCurrentItem(1); } 
if (x->getOption("Device", sectNum, "TwinViewOrientation") == "Above") { kComboBox15y->setCurrentItem(2); } 
if (x->getOption("Device", sectNum, "TwinViewOrientation") == "Below") { kComboBox15y->setCurrentItem(3); } 
if (x->getOption("Device", sectNum, "TwinViewOrientation") == "Clone") { kComboBox15y->setCurrentItem(4); } 
}
if (x->getOption("Device", sectNum, "ConnectedMonitor").section(", ", 0, 0) == "CRT") { kComboBox46->setCurrentItem(0); }
if (x->getOption("Device", sectNum, "ConnectedMonitor").section(", ", 0, 0) == "DFP") { kComboBox46->setCurrentItem(1); }
if (x->getOption("Device", sectNum, "ConnectedMonitor").section(", ", 0, 0) == "TV") { kComboBox46->setCurrentItem(2); }

if (x->getOption("Device", sectNum, "ConnectedMonitor").section(", ", 1, 1) == "CRT") { kComboBox46_2->setCurrentItem(0); }
if (x->getOption("Device", sectNum, "ConnectedMonitor").section(", ", 1, 1) == "DFP") { kComboBox46_2->setCurrentItem(1); }
if (x->getOption("Device", sectNum, "ConnectedMonitor").section(", ", 1, 1) == "TV") { kComboBox46_2->setCurrentItem(2); }

int a = 0;
while (a > -1)
{
if (x->getOption("Device", sectNum, "MetaModes").section(";", a, a) == "") { break; }
kListBox11->insertItem(x->getOption("Device", sectNum, "MetaModes").section(";", a, a).section(",", 0, 0).simplifyWhiteSpace());
kListBox11_2->insertItem(x->getOption("Device", sectNum, "MetaModes").section(";", a, a).section(",", 1, 1).simplifyWhiteSpace());
a++;
}
kListBox11->setSelected(0, TRUE);
kListBox11_2->setSelected(0, TRUE);

}
QString HorizontalSyncFrom = x->getOption("Device", sectNum, "SecondMonitorHorizSync").section("-", 0, 0).simplifyWhiteSpace().remove("kHz").remove("Hz");
QString HorizontalSyncTo = x->getOption("Device", sectNum, "SecondMonitorHorizSync").section("-", 1, 1).simplifyWhiteSpace().remove("kHz").remove("Hz");
QString VertRefFrom = x->getOption("Device", sectNum, "SecondMonitorVertRefresh").section("-", 0, 0).simplifyWhiteSpace().remove("kHz").remove("Hz");
QString VertRefTo = x->getOption("Device", sectNum, "SecondMonitorVertRefresh").section("-", 1, 1).simplifyWhiteSpace().remove("kHz").remove("Hz");
kLineEdit12->setText(HorizontalSyncFrom);
kLineEdit12_2->setText(HorizontalSyncTo);
kLineEdit12_3->setText(VertRefFrom);
kLineEdit12_2_2->setText(VertRefTo);




if (x->checkOption("Device", sectNum, "SWCursor")) { checkBox38->setChecked(TRUE); }
if (x->checkOption("Device", sectNum, "HWCursor")) { checkBox37->setChecked(TRUE); }

if (x->checkOption("Device", sectNum, "CursorShadow")) 
{
groupBox20->setChecked(TRUE);
bool ok;
QString num;
int a;
num = x->getOption("Device", sectNum, "CursorShadowAlpha");
a = num.toInt(&ok, 10);
slider2->setValue(a);
num = x->getOption("Device", sectNum, "CursorShadowXOffset");
a = num.toInt(&ok, 10);
slider2_2->setValue(a);
num = x->getOption("Device", sectNum, "CursorShadowYOffset");
a = num.toInt(&ok, 10);
slider2_2_2->setValue(a);
}



if (x->checkOption("Device", sectNum, "NoTwinViewXineramaInfo")) { checkBox17->setChecked(TRUE); }
if (x->checkOption("Device", sectNum, "UseClipIDs")) { checkBox18->setChecked(TRUE); }
if (x->checkOption("Device", sectNum, "NoBandWidthTest")) { checkBox19->setChecked(TRUE); }
if (x->checkOption("Device", sectNum, "MultisampleCompatibility")) { checkBox20->setChecked(TRUE); }

int a = 0;
QString tv = x->getOption("Device", sectNum, "TVStandard");
if (tv != "")
{
while (a <= kComboBox9->count())
{
if (kComboBox9->text(a) == tv) { kComboBox9->setCurrentItem(a); break; }
a++;
}
}
if (x->getOption("Device", sectNum, "TVOutFormat") ==  "SVIDEO") { kComboBox9_2->setCurrentItem(0); }
if (x->getOption("Device", sectNum, "TVOutFormat") ==  "COMPOSITE") { kComboBox9_2->setCurrentItem(1); }
QString overscan = x->getOption("Device", sectNum, "TVOverScan");
bool ok;
double ov = overscan.toDouble(&ok);
kDoubleNumInput1->setValue(ov);
kDoubleNumInput1->setMaxValue(1);


QString flatPanel = x->getOption("Device", sectNum, "FlatPanelProperties");
if (flatPanel.contains("Scaling = default") == 1) { kComboBox11->setCurrentItem(0); }
if (flatPanel.contains("Scaling = native") == 1) { kComboBox11->setCurrentItem(1); }
if (flatPanel.contains("Scaling = scaled") == 1) { kComboBox11->setCurrentItem(2); }
if (flatPanel.contains("Scaling = centered") == 1) { kComboBox11->setCurrentItem(3); }
if (flatPanel.contains("Scaling = aspect-scaled") == 1) { kComboBox11->setCurrentItem(4); }
if (flatPanel.contains("Dithering = default") == 1) { kComboBox11_2->setCurrentItem(0); }
if (flatPanel.contains("Dithering = enabled") == 1) { kComboBox11_2->setCurrentItem(1); }
if (flatPanel.contains("Dithering = disabled") == 1) { kComboBox11_2->setCurrentItem(2); }
if (x->getOption("Device", sectNum, "IgnoreDisplayDevices") != "")
{
groupBox14->setChecked(TRUE);
a = 0;
while (a > -1)
{
if (x->getOption("Device", sectNum, "IgnoreDisplayDevices").section(", ", a, a) == "") { break; }
kListBox3->insertItem(x->getOption("Device", sectNum, "IgnoreDisplayDevices").section(", ", a, a));
a++;
}
kListBox3->setSelected(0, TRUE);
}
checkAdapters();

}


QString nvidiaDriverOptionsBigDialog :: returnXorg()
{
return x->returnConfig();
}


void nvidiaDriverOptionsBigDialog :: slider1Update()
{
lCDNumber1->display(slider1->value());

}

void nvidiaDriverOptionsBigDialog :: cursorShadowSlidersUpdate()
{
lCDNumber2->display(slider2->value());
lCDNumber2_2->display(slider2_2->value());
lCDNumber2_2_2->display(slider2_2_2->value());

}


void nvidiaDriverOptionsBigDialog :: twinViewOrientationUpdate()
{
if (checkBox40->isChecked()) { kComboBox15y->setEnabled(TRUE); }
if (!checkBox40->isChecked()) { kComboBox15y->setEnabled(FALSE); }

}


void nvidiaDriverOptionsBigDialog :: checkAdapters()
{
cout << "CHECK" << endl;
if (kComboBox46->currentItem() != 1 && kComboBox46_2->currentItem() != 1) { groupBox13->setEnabled(FALSE); }
if (kComboBox46->currentItem() != 2 && kComboBox46_2->currentItem() != 2) { groupBox12->setEnabled(FALSE); }
if (kComboBox46->currentItem() == 1 || kComboBox46_2->currentItem() == 1) { groupBox13->setEnabled(TRUE); }
if (kComboBox46->currentItem() == 2 || kComboBox46_2->currentItem() == 2) { groupBox12->setEnabled(TRUE); }
}















void nvidiaDriverOptionsBigDialog :: accept()
{
QString y = "True";
if (checkBox25->isChecked()) { x->saveOption("Device", sectNum, "NoLogo", 1, y); }
if (!checkBox25->isChecked()) { x->removeOption("Device", sectNum, "NoLogo"); }
if (checkBox26->isChecked()) { x->saveOption("Device", sectNum, "RenderAccel", 1, y); }
if (!checkBox26->isChecked()) { x->removeOption("Device", sectNum, "RenderAccel"); }
if (checkBox27_2->isChecked()) { x->saveOption("Device", sectNum, "NoRenderExtension", 1, y); }
if (!checkBox27_2->isChecked()) { x->removeOption("Device", sectNum, "NoRenderExtension"); }
if (checkBox27->isChecked()) { x->saveOption("Device", sectNum, "UBB", 1, y); }
if (!checkBox27->isChecked()) { x->removeOption("Device", sectNum, "UBB"); }
if (checkBox27_3->isChecked()) { x->saveOption("Device", sectNum, "WindowFlip", 1, y); }
if (!checkBox27_3->isChecked()) { x->removeOption("Device", sectNum, "WindowFlip"); }
if (checkBox27_3_2->isChecked()) { x->saveOption("Device", sectNum, "PageFlip", 1, y); }
if (!checkBox27_3_2->isChecked()) { x->removeOption("Device", sectNum, "PageFlip"); }
if (checkBox31->isChecked()) { x->saveOption("Device", sectNum, "Dac8Bit", 1, y); }
if (!checkBox31->isChecked()) { x->removeOption("Device", sectNum, "Dac8Bit"); }
if (checkBox32->isChecked()) { x->saveOption("Device", sectNum, "Overlay", 1, y); }
if (!checkBox32->isChecked()) { x->removeOption("Device", sectNum, "Overlay"); }
if (checkBox33->isChecked()) { x->saveOption("Device", sectNum, "CIOverlay", 1, y); }
if (!checkBox33->isChecked()) { x->removeOption("Device", sectNum, "CIOverlay"); }
if (checkBox35->isChecked()) { x->saveOption("Device", sectNum, "OverlayDefaultVisual", 1, y); }
if (!checkBox35->isChecked()) { x->removeOption("Device", sectNum, "OverlayDefaultVisual"); }
if (checkBox15->isChecked()) { x->saveOption("Device", sectNum, "UseEdidFreqs", 1, y); }
if (!checkBox15->isChecked()) { x->removeOption("Device", sectNum, "UseEdidFreqs"); }
if (checkBox16->isChecked()) { x->saveOption("Device", sectNum, "IgnoreEDID", 1, y); }
if (!checkBox16->isChecked()) { x->removeOption("Device", sectNum, "IgnoreEDID"); }
if (checkBox17->isChecked()) { x->saveOption("Device", sectNum, "NoTwinViewXineramaInfo", 1, y); }
if (!checkBox17->isChecked()) { x->removeOption("Device", sectNum, "NoTwinViewXineramaInfo"); }
if (checkBox18->isChecked()) { x->saveOption("Device", sectNum, "UseClipIDs", 1, y); }
if (!checkBox18->isChecked()) { x->removeOption("Device", sectNum, "UseClipIDs"); }
if (checkBox19->isChecked()) { x->saveOption("Device", sectNum, "NoBandWidthTest", 1, y); }
if (!checkBox19->isChecked()) { x->removeOption("Device", sectNum, "NoBandWidthTest"); }
if (checkBox20->isChecked()) { x->saveOption("Device", sectNum, "MultisampleCompatibility", 1, y); }
if (!checkBox20->isChecked()) { x->removeOption("Device", sectNum, "MultisampleCompatibility"); }
if (checkBox37->isChecked()) { x->saveOption ("Device", sectNum, "HWCursor", 1, y); }
if (!checkBox37->isChecked()) { x->removeOption("Device", sectNum, "HWCursor"); }
if (checkBox38->isChecked()) { x->saveOption ("Device", sectNum, "SWCursor", 1, y); }
if (!checkBox38->isChecked()) { x->removeOption("Device", sectNum, "SWCursor"); }


if (!groupBox10->isChecked()) { x->removeOption("Device", sectNum, "Stereo"); }
if (groupBox10->isChecked()) 
{
if (kComboBox7DDC_Glasses->currentItem() == 0) { x->saveOption("Device", sectNum, "Stereo", 1, "1"); }
if (kComboBox7DDC_Glasses->currentItem() == 1) { x->saveOption("Device", sectNum, "Stereo", 1, "2"); }
if (kComboBox7DDC_Glasses->currentItem() == 2) { x->saveOption("Device", sectNum, "Stereo", 1, "3"); }
if (kComboBox7DDC_Glasses->currentItem() == 3) { x->saveOption("Device", sectNum, "Stereo", 1, "4"); }
}
if (!groupBox18->isChecked()) { x->removeOption("Device", sectNum, "NvAGP"); }
if (groupBox18->isChecked())
{
if (kComboBox14->currentItem() == 0) { x->saveOption("Device", sectNum, "NvAGP", 1, "0"); }
if (kComboBox14->currentItem() == 1) { x->saveOption("Device", sectNum, "NvAGP", 1, "1"); }
if (kComboBox14->currentItem() == 2) { x->saveOption("Device", sectNum, "NvAGP", 1, "2"); }
if (kComboBox14->currentItem() == 3) { x->saveOption("Device", sectNum, "NvAGP", 1, "3"); }
}
if (!groupBox17->isChecked()) { x->removeOption("Device", sectNum, "DigitalVibrance"); }
if (groupBox17->isChecked()) 
{
QString num;
num = num.setNum(slider1->value(), 10);
x->saveOption("Device", sectNum, "DigitalVibrance", 1, num);
}

//TwinView

if (!groupBox19->isChecked())
{
x->removeOption("Device", sectNum, "TwinView");
x->removeOption("Device", sectNum, "TwinViewOrientation");
x->removeOption("Device", sectNum, "ConnectedMonitor");
x->removeOption("Device", sectNum, "SecondMonitorHorizSync");
x->removeOption("Device", sectNum, "SecondMonitorVertRefresh");
x->removeOption("Device", sectNum, "MetaModes");
}
if (groupBox19->isChecked())
{
if (kComboBox15y->currentItem() == 0) { x->saveOption("Device", sectNum, "TwinView", 1, y); }
if (kComboBox15y->currentItem() == 0) { x->saveOption("Device", sectNum, "TwinViewOrientation", 1, "RightOf"); }
if (kComboBox15y->currentItem() == 1) { x->saveOption("Device", sectNum, "TwinViewOrientation", 1, "LeftOf"); }
if (kComboBox15y->currentItem() == 2) { x->saveOption("Device", sectNum, "TwinViewOrientation", 1, "Above"); }
if (kComboBox15y->currentItem() == 3) { x->saveOption("Device", sectNum, "TwinViewOrientation", 1, "Below"); }
if (kComboBox15y->currentItem() == 4) { x->saveOption("Device", sectNum, "TwinViewOrientation", 1, "Clone"); }
x->removeOption("Device", sectNum, "ConnectedMonitor");
QString ConnectedMonitors = kComboBox46->text(kComboBox46->currentItem()).section(" - ", 0, 0) + ", " + kComboBox46_2->text(kComboBox46_2->currentItem()).section(" - ", 0, 0);
x->saveOption("Device", sectNum, "ConnectedMonitor", 1, ConnectedMonitors);
}
QString horizSync = kLineEdit12->text() + " - " + kLineEdit12_2->text();
if (kLineEdit12->text() != "" && kLineEdit12_2->text() != "") { x->saveOption("Device", sectNum, "SecondMonitorHorizSync", 1, horizSync); }
QString vertRef = kLineEdit12_3->text() + " - " + kLineEdit12_2_2->text();
if (kLineEdit12_3->text() != "" && kLineEdit12_2_2->text() != "") { x->saveOption("Device", sectNum, "SecondMonitorVertRefresh", 1, vertRef); }

int a = 0;
QString metaModes = "";
while (a < kListBox11->count())
{
metaModes = metaModes.append(kListBox11->text(a) + ", " + kListBox11_2->text(a) + "; ");
a++;
}
metaModes.truncate(metaModes.length() - 2);
x->removeOption("Device", sectNum, "MetaModes");

if (metaModes != "") { x->saveOption("Device", sectNum, "MetaModes", 1, metaModes); }

if (!groupBox20->isChecked())
{
x->removeOption("Device", sectNum, "CursorShadow");
x->removeOption("Device", sectNum, "CursorShadowAlpha");
x->removeOption("Device", sectNum, "CursorShadowXOffset");
x->removeOption("Device", sectNum, "CursorShadowYOffset");
}

if (groupBox20->isChecked())
{
x->removeOption("Device", sectNum, "CursorShadow");
x->saveOption("Device", sectNum, "CursorShadow", 1, y);
QString num;
num = num.setNum(slider2->value(), 10);
x->saveOption("Device", sectNum, "CursorShadowAlpha", 1, num);
num = num.setNum(slider2_2->value(), 10);
x->saveOption("Device", sectNum, "CursorShadowXOffset", 1, num);
num = num.setNum(slider2_2_2->value(), 10);
x->saveOption("Device", sectNum, "CursorShadowYOffset", 1, num);
}
if (!groupBox12->isEnabled())
{
x->removeOption("Device", sectNum, "TVStandard");
x->removeOption("Device", sectNum, "TVOutFormat");
x->removeOption("Device", sectNum, "TVOverScan");
}
if (groupBox12->isEnabled())
{
x->saveOption("Device", sectNum, "TVStandard", 1, kComboBox9->text(kComboBox9->currentItem()));
if (kComboBox9_2->currentItem() == 0)
{
x->saveOption("Device", sectNum, "TVOutFormat", 1, "SVIDEO");
}
if (kComboBox9_2->currentItem() == 1)
{
x->saveOption("Device", sectNum, "TVOutFormat", 1, "COMPOSITE");
}

QString num;
num = num.setNum(kDoubleNumInput1->value(), 'f', 1);
x->saveOption("Device", sectNum, "TVOverScan", 1, num);
}


if (!groupBox14->isChecked())
{
x->removeOption("Device", sectNum, "IgnoreDisplayDevices");
}


if (groupBox14->isChecked())
{
QString ignoreList;
int a = 0;
while (a <= kListBox3->count() && kListBox3->count() > 0)
{
ignoreList = ignoreList.append(kListBox3->text(a) + ", ");
a++;
}
ignoreList.truncate(ignoreList.length() - 4);
x->removeOption("Device", sectNum, "IgnoreDisplayDevices");
x->saveOption("Device", sectNum, "IgnoreDisplayDevices", 1, ignoreList);
}







close();
}

void nvidiaDriverOptionsBigDialog :: horizSyncCheck()
{
if (checkBox15->isChecked()) { groupBox21->setEnabled(FALSE); }
if (!checkBox15->isChecked()) { groupBox21->setEnabled(TRUE); }
if (checkBox15->isChecked()) { checkBox16->setChecked(FALSE); }
}

void nvidiaDriverOptionsBigDialog :: vertRefCheck()
{
if (checkBox16->isChecked()) { groupBox21->setEnabled(TRUE); }
if (checkBox16->isChecked()) { checkBox15->setChecked(FALSE); }
}

void nvidiaDriverOptionsBigDialog :: addMetaMode()
{
if (kListBox11->findItem(modeComboBox->text(modeComboBox->currentItem())) != 0 && kListBox11_2->findItem(modeComboBox_2->text(modeComboBox_2->currentItem()))) 
{
KMessageBox::sorry(this, locRet(1), "kX Generator", KMessageBox::Notify); return;
return;
}
kListBox11->insertItem(modeComboBox->text(modeComboBox->currentItem()));
kListBox11_2->insertItem(modeComboBox_2->text(modeComboBox_2->currentItem()));

}

void nvidiaDriverOptionsBigDialog :: removeMetaMode()
{
int a = kListBox11->currentItem();
kListBox11->removeItem(a);
kListBox11_2->removeItem(a);
if (a == kListBox11->count()) 
{
kListBox11->setSelected(a, TRUE);
kListBox11_2->setSelected(a, TRUE);
}

}

void nvidiaDriverOptionsBigDialog :: leftListBoxClicked() { kListBox11_2->setSelected(kListBox11->currentItem(), TRUE); }
void nvidiaDriverOptionsBigDialog :: rightListBoxClicked() { kListBox11->setSelected(kListBox11_2->currentItem(), TRUE); }
void nvidiaDriverOptionsBigDialog :: hwCursor() { if (checkBox37->isChecked()) { checkBox38->setChecked(FALSE); } }
void nvidiaDriverOptionsBigDialog :: swCursor() { if (checkBox38->isChecked()) { checkBox37->setChecked(FALSE); } }

void nvidiaDriverOptionsBigDialog :: addIgnoreDevice()
{
int a = kListBox3->currentItem();
QStringList list;
bool add = false;
if (kListBox3->findItem("TV") == 0) { list.append("TV"); add = true; }
if (kListBox3->findItem("CRT") == 0) { list.append("CRT"); add = true; }
if (kListBox3->findItem("DFP") == 0) { list.append("DFP"); add = true; }
if (!add) { KMessageBox::sorry(this, locRet(4), "kX Generator", KMessageBox::Notify); return; }
QString toInsert = KInputDialog::getItem(locRet(2), locRet(3), list, 0, false, 0, this);
if (toInsert != "") { kListBox3->insertItem(toInsert); }
kListBox3->setSelected(a, TRUE);
if (a < 0) { kListBox3->setSelected(0, TRUE); }
}

void nvidiaDriverOptionsBigDialog :: removeIgnoreDevice()
{
int a = kListBox3->currentItem();
kListBox3->removeItem(a);
kListBox3->setSelected(a, TRUE);
if (a == kListBox3->count()) { kListBox3->setSelected(a - 1, TRUE); }
}

#include "nvidiadriveroptionsbigdialog.moc"
